<?php

namespace App\Models;

use CodeIgniter\Model;

class ActivityLogModel extends Model
{
    protected $table = 'activity_logs';
    protected $primaryKey = 'id';
    protected $allowedFields = ['request_id', 'user_id', 'activity', 'created_at'];
    protected $useTimestamps = true;
    protected $createdField  = 'created_at';
    protected $updatedField  = 'updated_at';

    public function log($requestId, $userId, $activity)
    {
        return $this->insert([
            'request_id' => $requestId,
            'user_id' => $userId,
            'activity' => $activity,
          	'created_at' => date('Y-m-d H:i:s')
        ]);
    }

    public function getRequestActivities($requestId)
    {
        return $this->select('activity_logs.*, users.username')
                    ->join('users', 'users.id = activity_logs.user_id')
                    ->where('request_id', $requestId)
                    ->orderBy('activity_logs.created_at', 'DESC')
                    ->findAll();
    }
}